; -------------------------------------------------------------------------
; The text is extracted from the Screen Buffer and prepared to be copied 
; into the Windows Clipboard with [code] and [/code] enclosing it and with 
; LF+CR at the end of each text line. 
; -------------------------------------------------------------------------

CopyScreenText PROC


    lea  esi, TopCode
    lea  edi, TextResults 

    movq mm7, qword ptr [esi]
    movq qword ptr [edi], mm7

    add  edi, Eight   
    lea  esi, SavedScreen

    mov  ecx, CharNumber
    
    xor  eax, eax
    xor  ebx, ebx 



NextCharText:

    mov eax, [esi]
    
    mov BYTE PTR [edi], al

    add esi, Four
    add edi, One
    inc ebx

    cmp ebx, MaxCols
    jl  GoOn

    mov BYTE PTR [edi], CR
    mov BYTE PTR [edi + 1], LF
    add edi, Two
    xor ebx, ebx

GoOn:

    dec ecx
    jnz NextCharText 

SetNULL:

    lea  esi, BottomCode

    movq mm7, qword ptr [esi]
    movq qword ptr [edi], mm7

    add  edi, Eight   

    mov WORD PTR [edi], 00A0h;   CR + NULL


End_cycle:

    ret 
    
CopyScreenText ENDP
; -------------------------------------------------------------------------
; The text extracted from the Screen Buffer is copied 
; into the Windows Clipboard with [code] and [/code] enclosing it and with 
; LF+CR at the end of each text line. 
; -------------------------------------------------------------------------

CopyTextToClipboard PROC

.data 
    
    hglb dd 0
    
.code

;--------------------------------------------------------------------------
; Copy TextResults to the clipboard.
;--------------------------------------------------------------------------

    mov  Lenght, len(ADDR TextResults)

    invoke OpenClipboard,NULL
    
    .IF (eax)
    
      invoke EmptyClipboard

      invoke GlobalAlloc,GMEM_MOVEABLE,DWORD PTR Lenght
      
      .IF (eax)
      
        mov hglb, eax

        invoke GlobalLock,hglb
        
          ;---------------------
          ; Pointer now in eax.
          ;---------------------
          
        invoke MemCopy,ADDR TextResults,eax,DWORD PTR Lenght

        invoke GlobalUnlock,hglb
        
        invoke SetClipboardData,CF_OEMTEXT,hglb
        
          ;--------------------------------------------
          ; System now owns object identified by hglb.
          ;--------------------------------------------
          
        .IF (eax == 0)

          loc 4, 22
        
          print "SetClipboardData failed",13,10
          
        .ENDIF
        
      .ELSE

        loc 4, 22
      
        print "GlobalAlloc failed",13,10
        
      .ENDIF
      
  
    .ELSE

      loc 4, 22
    
      print "OpenClipboard failed",13,10
      
    .ENDIF

    invoke CloseClipboard

    .IF (eax == 0)

      loc 4, 22
    
      print "CloseClipboard failed"
      
    .ENDIF




    ret



CopyTextToClipboard ENDP
